// FileDateDlg.cpp : implementation file
//  Author: T.Yogaramanan

#include "stdafx.h"
#include "FileDate.h"
#include "FileDateDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileDateDlg dialog

CFileDateDlg::CFileDateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileDateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileDateDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFileDateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileDateDlg)
	DDX_Control(pDX, IDC_EDTPATH, m_edtPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFileDateDlg, CDialog)
	//{{AFX_MSG_MAP(CFileDateDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTNSELFILE, OnBtnSelFile)
	ON_BN_CLICKED(IDC_BTNSELDIR, OnBtnSelDir)
	ON_BN_CLICKED(IDC_BTNREFRESH, OnBtnRefresh)
	ON_BN_CLICKED(IDC_BTNAPPLY, OnBtnApply)
	ON_BN_CLICKED(IDC_CHKIGNOREATTR, OnChkIgnoreAttr)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileDateDlg message handlers

BOOL CFileDateDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// register drag & drop
	m_edtPath.InitDragDrop();

	((CButton*)GetDlgItem(IDC_CHKSUBITEMS))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_CHKAPPLYPARENT))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_CHKIGNOREATTR))->SetCheck(false);

	((CButton*)GetDlgItem(IDC_CHKHIDDEN))->SetCheck(false);
	((CButton*)GetDlgItem(IDC_CHKSYSTEM))->SetCheck(false);
	((CButton*)GetDlgItem(IDC_CHKREADONLY))->SetCheck(false);

	GetDlgItem(IDC_CHKHIDDEN)->EnableWindow(false);
	GetDlgItem(IDC_CHKSYSTEM)->EnableWindow(false);
	GetDlgItem(IDC_CHKREADONLY)->EnableWindow(false);
	GetDlgItem(IDC_CHKCOMPRESSED)->EnableWindow(false);
	GetDlgItem(IDC_CHKENCRYPTED)->EnableWindow(false);


	m_edtPath.SetWindowText(strrchr(GetCommandLine(),'"')+1);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFileDateDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFileDateDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFileDateDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFileDateDlg::OnBtnSelFile() 
{
	CFileDialog cFDlg(true,NULL,NULL,0);
	CString cszStr;
	if(cFDlg.DoModal() ==IDOK)
		m_edtPath.SetWindowText(cFDlg.GetPathName());
}

void CFileDateDlg::OnCancel() 
{
	if(AfxMessageBox("Exit ?",MB_ICONQUESTION|MB_YESNO)==IDNO)
		return;
	
	CDialog::OnCancel();
}

void CFileDateDlg::OnOK() 
{

}

void CFileDateDlg::OnChkIgnoreAttr() 
{
	if(((CButton*)GetDlgItem(IDC_CHKIGNOREATTR))->GetCheck())
	{
		GetDlgItem(IDC_CHKHIDDEN)->EnableWindow(true);
		GetDlgItem(IDC_CHKSYSTEM)->EnableWindow(true);
		GetDlgItem(IDC_CHKREADONLY)->EnableWindow(true);
		GetDlgItem(IDC_CHKCOMPRESSED)->EnableWindow(true);
		GetDlgItem(IDC_CHKENCRYPTED)->EnableWindow(true);
	}
	else
	{
		GetDlgItem(IDC_CHKHIDDEN)->EnableWindow(false);
		GetDlgItem(IDC_CHKSYSTEM)->EnableWindow(false);
		GetDlgItem(IDC_CHKREADONLY)->EnableWindow(false);
		GetDlgItem(IDC_CHKCOMPRESSED)->EnableWindow(false);
		GetDlgItem(IDC_CHKENCRYPTED)->EnableWindow(false);
	}
}

void CFileDateDlg::OnBtnSelDir() 
{
	BROWSEINFO binfo;
	char szDispName[_MAX_PATH+2];
	char szPath[_MAX_PATH+2];

	binfo.hwndOwner = this->m_hWnd;
    binfo.pidlRoot = NULL;
    binfo.pszDisplayName = szDispName;
    binfo.lpszTitle = "Choose a folder";
    binfo.ulFlags = 0;
    binfo.lpfn = NULL;
    binfo.lParam = 0;

	CoInitialize(0);
	LPITEMIDLIST  piList = SHBrowseForFolder(&binfo);
	SHGetPathFromIDList(piList,szPath);
	m_edtPath.SetWindowText(szPath);
}


// this a get date & time function
int GetFileDateTime(char *szFilePath, 
					FILETIME &ftCreated, 
					FILETIME &ftModified, 
					FILETIME &ftAccessed)
{
    HANDLE hFile = CreateFile(szFilePath,
			GENERIC_READ,FILE_SHARE_DELETE|FILE_SHARE_READ|FILE_SHARE_WRITE,
			NULL,
			OPEN_EXISTING,
			FILE_FLAG_BACKUP_SEMANTICS,
			NULL);

    if(hFile == INVALID_HANDLE_VALUE)
		return 1;

    BOOL bVal = GetFileTime(hFile,&ftCreated,&ftAccessed,&ftModified);

    CloseHandle(hFile);
    if(!bVal)
		return 2;
    return 0;
}

BOOL g_bIgnoreAttrAndApply = false;
BOOL g_bAttrHidden = false;
BOOL g_bAttrSystem = false;
BOOL g_bAttrReadOnly = false;
BOOL g_bAttrCompressed = false;
BOOL g_bAttrEncrypted = false;

// its a independent funtion will set the date and time
///   its a core function in this tool
int SetFileDateTime(char *szFilePath, 
					FILETIME ftCreated, 
					FILETIME ftModified, 
					FILETIME ftAccessed)
{
	DWORD dwAttr;
	dwAttr = GetFileAttributes(szFilePath);
	
	if(g_bIgnoreAttrAndApply)
	{// to ignore mean resets the file/folder attributes to normal
	 //		 and again it will be set back

		if(FILE_ATTRIBUTE_HIDDEN&dwAttr)
			if(!g_bAttrHidden)
				return 0;
		if(FILE_ATTRIBUTE_READONLY&dwAttr)
			if(!g_bAttrReadOnly)
				return 0;
		if(FILE_ATTRIBUTE_SYSTEM&dwAttr)
			if(!g_bAttrSystem)
				return 0;
		if(FILE_ATTRIBUTE_COMPRESSED&dwAttr)
			if(!g_bAttrCompressed)
				return 0;
		if(FILE_ATTRIBUTE_ENCRYPTED&dwAttr)
			if(!g_bAttrEncrypted)
				return 0;

		SetFileAttributes(szFilePath,FILE_ATTRIBUTE_NORMAL);
	}
	else
	{// if not to ignore, then the following 
	 //		attributed file/folder can not be set to new file xdate time

		if(FILE_ATTRIBUTE_HIDDEN&dwAttr)
			return 0;
		if(FILE_ATTRIBUTE_READONLY&dwAttr)
			return 0;
		if(FILE_ATTRIBUTE_SYSTEM&dwAttr)
			return 0;
		if(FILE_ATTRIBUTE_COMPRESSED&dwAttr)
			return 0;
		if(FILE_ATTRIBUTE_ENCRYPTED&dwAttr)
			return 0;
	}

	// open the file/folder
	HANDLE hFile = CreateFile(szFilePath,
						GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,
						NULL,
						OPEN_EXISTING,
						FILE_FLAG_BACKUP_SEMANTICS,
						NULL);

	if(hFile == INVALID_HANDLE_VALUE)
		return 1;

	// set date time
    BOOL bVal = SetFileTime(hFile,&ftCreated,&ftAccessed,&ftModified);
	if(!bVal)
	{
		char *szBuff = (char*)malloc(sizeof(char)*1024);
		LPVOID lpMsgBuf;
		int err = GetLastError();

		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM,
					NULL, 
					err, 
					MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
					(LPTSTR) &lpMsgBuf, 
					0, 
					NULL);

		sprintf(szBuff,"Unable to set date to \n  %s \n\nReason:%s \nError No:%d",
				szFilePath,lpMsgBuf,err),

		MessageBox(NULL,(LPTSTR)lpMsgBuf, "GetLastError", MB_OK|MB_ICONERROR);
		LocalFree(lpMsgBuf);
	}

	// close the handle
    CloseHandle(hFile);
	
	// if it is ignore then it should be set back to its original attribute
	if(g_bIgnoreAttrAndApply)
		SetFileAttributes(szFilePath,dwAttr);
	
	if(!bVal)
		return 2;
    return 0;
}

// it is a recursive function will 
//				go through the files and folders within any folder
int SetDateTimeToFolderFiles(HANDLE hSearchedFile, 
							 char *szPathName, 
							 FILETIME ftCreated, 
							 FILETIME ftModified, 
							 FILETIME ftAccessed)
{
	WIN32_FIND_DATA stFindData;
	char *szCurFilename = (char*)malloc(sizeof(char)*_MAX_PATH);
	char *szCurPathname = (char*)malloc(sizeof(char)*_MAX_PATH);

	strcpy(szCurFilename,szPathName);
	strcpy(szCurPathname,szPathName);

	if((hSearchedFile == NULL)||(hSearchedFile ==INVALID_HANDLE_VALUE))
	{// start the search
		sprintf(szCurFilename,"%s\\*.*",szPathName);

		hSearchedFile = FindFirstFile(szCurFilename,&stFindData);
		if(hSearchedFile == INVALID_HANDLE_VALUE)
			return 0;
	}
	else
	{
		if(!FindNextFile(hSearchedFile,&stFindData))
		{// if no more file exists close it
			FindClose(hSearchedFile);
			return 0;
		}
	}

	strcat(szCurPathname,"\\");
	strcat(szCurPathname,stFindData.cFileName);

	if(stFindData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
	{// if it is a folder then ....
		if((!stricmp(stFindData.cFileName,"."))||
			(!stricmp(stFindData.cFileName,".."))||
			(!stricmp(stFindData.cFileName,""))||
			(!stricmp(stFindData.cFileName,"")))
		{
			// call it recursively
			return SetDateTimeToFolderFiles(hSearchedFile, 
											szPathName, 
											ftCreated,
											ftModified, 
											ftAccessed);
        }
		
		// call the set function for the found folder
		SetFileDateTime(szCurPathname, ftCreated, ftModified, ftAccessed);

		// call it recursively
		SetDateTimeToFolderFiles(	NULL, 
									szCurPathname, 
									ftCreated, 
									ftModified,
									ftAccessed);
    }

	// control will come here only if the found one is a file


	//  set the date time to the file
	SetFileDateTime(szCurPathname, ftCreated, ftModified, ftAccessed);

	// call it recursively
	return SetDateTimeToFolderFiles(hSearchedFile, 
									szPathName, 
									ftCreated,
									ftModified, 
									ftAccessed);
}

// refresh will get date and time from folder/file and
//   CdateTimeCtrl will be populated with it
void CFileDateDlg::OnBtnRefresh() 
{
	CString cszPath;
	m_edtPath.GetWindowText(cszPath);

	FILETIME ftCreated, ftModified, ftAccessed;
	BOOL bRet = GetFileDateTime(cszPath.GetBuffer(0),
								ftCreated, 
								ftModified, 
								ftAccessed);
	cszPath.ReleaseBuffer();

	((CDateTimeCtrl*)GetDlgItem(IDC_DATECREATED))->SetTime(ftCreated);
	((CDateTimeCtrl*)GetDlgItem(IDC_DATEMODIFIED))->SetTime(ftModified);
	((CDateTimeCtrl*)GetDlgItem(IDC_DATEACCESSED))->SetTime(ftAccessed);

	((CDateTimeCtrl*)GetDlgItem(IDC_TIMECREATED))->SetTime(ftCreated);
	((CDateTimeCtrl*)GetDlgItem(IDC_TIMEMODIFIED))->SetTime(ftModified);
	((CDateTimeCtrl*)GetDlgItem(IDC_TIMEACCESSED))->SetTime(ftAccessed);

}

void CFileDateDlg::OnBtnApply() 
{
	CString cszPath;
	m_edtPath.GetWindowText(cszPath);
	cszPath.TrimLeft();
	cszPath.TrimRight();
	if(cszPath == "")
	{
		MessageBox("Cannot apply the dates !\n	\
			No folders or files have been selected",
			"FileDate Warning",MB_OK|MB_ICONWARNING);
		return;
	}

    COleDateTime coleDate, coleTime;
    SYSTEMTIME sysTime,sysDate;
    FILETIME ftCreated,ftModified,ftAccessed;
    BOOL bRet;

	// get the attribute settings
	g_bIgnoreAttrAndApply = ((CButton*)GetDlgItem(IDC_CHKIGNOREATTR))->GetCheck();
	g_bAttrHidden = ((CButton*)GetDlgItem(IDC_CHKHIDDEN))->GetCheck();
	g_bAttrReadOnly = ((CButton*)GetDlgItem(IDC_CHKREADONLY))->GetCheck();
	g_bAttrSystem  = ((CButton*)GetDlgItem(IDC_CHKSYSTEM))->GetCheck();
	g_bAttrEncrypted = ((CButton*)GetDlgItem(IDC_CHKENCRYPTED))->GetCheck();
	g_bAttrCompressed = ((CButton*)GetDlgItem(IDC_CHKCOMPRESSED))->GetCheck();

////////// created date & time ///////////////////////////////////////////////////////
	// get the date & time from the CDateTimeCtrl s as COleDateTime
    ((CDateTimeCtrl*)GetDlgItem(IDC_DATECREATED))->GetTime(coleDate);
    ((CDateTimeCtrl*)GetDlgItem(IDC_TIMECREATED))->GetTime(coleTime);

	// now convert from COleDateTime to SYSTEMTIME
    coleDate.GetAsSystemTime(sysDate);
    coleTime.GetAsSystemTime(sysTime);

    sysDate.wMilliseconds	=sysTime.wMilliseconds;
    sysDate.wSecond			=sysTime.wSecond;
    sysDate.wMinute			=sysTime.wMinute;
    sysDate.wHour			=sysTime.wHour;


	// now convert SYSTEMTIME to FILETIME
    SystemTimeToFileTime(&sysDate,&ftAccessed); // don't confuse by ftAccessed usage, 
												// it is just a temporary variable

	// then convert local FILETIME to Coordinated Universal Time
    LocalFileTimeToFileTime(&ftAccessed,&ftAccessed);

	// now convert Universal Time to system time then to file time 
	//   the one will be passed to the function to set
    FileTimeToSystemTime(&ftAccessed,&sysDate);
    bRet = SystemTimeToFileTime(&sysDate,&ftCreated);

///////////////// modified date & time ////////////////////////////////////////////////
	// get the date & time from the CDateTimeCtrl s as COleDateTime
	((CDateTimeCtrl*)GetDlgItem(IDC_DATEMODIFIED))->GetTime(coleDate);
    ((CDateTimeCtrl*)GetDlgItem(IDC_TIMEMODIFIED))->GetTime(coleTime);

	// now convert from COleDateTime to SYSTEMTIME
    coleDate.GetAsSystemTime(sysDate);
    coleTime.GetAsSystemTime(sysTime);

    sysDate.wMilliseconds	=sysTime.wMilliseconds;
    sysDate.wSecond			=sysTime.wSecond;
    sysDate.wMinute			=sysTime.wMinute;
    sysDate.wHour			=sysTime.wHour;

	// now convert SYSTEMTIME to FILETIME
    SystemTimeToFileTime(&sysDate,&ftAccessed); // don't confuse by ftAccessed
												// it is just a temporary variable


	// then convert local FILETIME to Coordinated Universal Time
    LocalFileTimeToFileTime(&ftAccessed,&ftAccessed);

	// now convert Universal Time to system time then to file time 
	//   the one will be passed to the function to set 
	FileTimeToSystemTime(&ftAccessed,&sysDate);
    bRet = SystemTimeToFileTime(&sysDate,&ftModified);

///////////////// Accessed date & time /////////////////////////////////////////////////
	// get the date & time from the CDateTimeCtrl s as COleDateTime
	((CDateTimeCtrl*)GetDlgItem(IDC_DATEACCESSED))->GetTime(coleDate);
    ((CDateTimeCtrl*)GetDlgItem(IDC_TIMEACCESSED))->GetTime(coleTime);

	// now convert from COleDateTime to SYSTEMTIME
    coleDate.GetAsSystemTime(sysDate);
    coleTime.GetAsSystemTime(sysTime);

    sysDate.wMilliseconds	=sysTime.wMilliseconds;
    sysDate.wSecond			=sysTime.wSecond;
    sysDate.wMinute			=sysTime.wMinute;
    sysDate.wHour			=sysTime.wHour;

	// now convert SYSTEMTIME to FILETIME
    SystemTimeToFileTime(&sysDate,&ftAccessed);

	// then convert local FILETIME to Coordinated Universal Time
    LocalFileTimeToFileTime(&ftAccessed,&ftAccessed);
    
	// now convert Universal Time to system time then to file time 
	//   the one will be passed to the function to set
	FileTimeToSystemTime(&ftAccessed,&sysDate);
    bRet = SystemTimeToFileTime(&sysDate,&ftAccessed);


	if((GetFileAttributes(cszPath.GetBuffer(0))&FILE_ATTRIBUTE_DIRECTORY))
	{// if it is a folder then .....
		cszPath.ReleaseBuffer();

		if(((CButton*)GetDlgItem(IDC_CHKSUBITEMS))->GetCheck())
		{// if the user specified to apply (set date time ) 
			//				the contents within the folder then......
			SetDateTimeToFolderFiles(	NULL,
										cszPath.GetBuffer(0),
										ftCreated,
										ftModified,
										ftAccessed);
			cszPath.ReleaseBuffer();
		}
		if(((CButton*)GetDlgItem(IDC_CHKAPPLYPARENT))->GetCheck())
		{// if the user specified to apply (set date time ) 
			//				to the selected folder then...
			SetFileDateTime(cszPath.GetBuffer(0),ftCreated,ftModified,ftAccessed);
			cszPath.ReleaseBuffer();
		}
		if((!(((CButton*)GetDlgItem(IDC_CHKSUBITEMS))->GetCheck()))&&
				(!(((CButton*)GetDlgItem(IDC_CHKAPPLYPARENT))->GetCheck())))
			MessageBox("Nothing selected to apply\n	\
			You have selected a folder to apply\n	\
			But you haven't checked any of the first two check boxes",
			"FileDate Warning",MB_OK|MB_ICONWARNING);

	}
    else
	{// if it is not a folder then just apply (set date time ) to that file
		SetFileDateTime(cszPath.GetBuffer(0),ftCreated,ftModified,ftAccessed);
		cszPath.ReleaseBuffer();
	}
}




